(*****************************************)
(* TMTDLL 2.01 - indirect import example *)
(* Copyleft (C) 1999 Virtual Research    *)
(*                                       *)
(* This program imports Foo and Bar from *)
(* INDIRECT.DLL                          *)
(*****************************************)

program Indirect;
uses DLL,IndirInt;

var H:TDLLHandle;
    _Interface:PInterface;
    a,b:real;   (* Vector components *)

begin
 H:=dllLoad('INDIRECT');
 if dllError<>0 then begin
  WriteLn(dllErrorMessage[dllError]);
  Halt;
 end;
 WriteLn('DLL exit code is: ',dllExitCode);
 
 _Interface:=PInterface(dllGetObjectAddressByName(H,'Interface'));
 if dllError<>0 then begin
  dllFree(H);
  WriteLn(dllErrorMessage[dllError]);
  Halt;
 end;
 
 _Interface^.Foo(a,b);
 WriteLn(_Interface^.Bar(a,b));
 
 dllFree(H);    (* Unload DLL *)
end.
