(*********************************************)
(* Example program for CDAUDIO.DLL           *)
(* Copyleft (C) 1999 Virtual Research        *)
(*********************************************)

uses DLL,CDAudio_;
var Handle:TDLLHandle;
    CDA:PCDAudio;
    i:byte;
const IsAudio:array[boolean] of string[5]=('Audio','Data ');
begin
 Handle:=dllLoad('CDAUDIO');
 CDA:=dllGetObjectAddressByName(Handle,'CDAudio');
 with CDA^ do begin
  while not Result^ do begin
   WriteLn('Insert audio CD please, then press Enter');
   ReadLn;
   ChangeDisk(0);
  end;
  WriteLn('Disk contains ',NumberOfTracks^,' tracks');
  for i:=0 to NumberOfTracks^-1 do
   WriteLn(i:2,': ',IsAudio[Tracks^[i].DataTrack],' track, ',
           Tracks^[i].Minutes:2,':',Tracks^[i].Seconds:2);
  WriteLn;
  repeat
   Write('Which track to play? ');
   ReadLn(i);
  until (i<NumberOfTracks^) and (not Tracks^[i].DataTrack);
  WriteLn('Playing, press Enter to stop');
  PlayTrack(i);
  ReadLn;
  WriteLn('Shutting down...');
  Stop;
  Seek(1);
 end;
 dllFree(Handle);
end.

