(**************************************************)
(* TMTDLL version info dumper, v. 1.03            *)
(* Copyleft (C) 2000 Virtual Research             *)
(**************************************************)

{$I release.opt}
uses DOS,DLL;
var dllname,path,dummy:string;
    handle:tdllhandle;
    version:string;
    description:pchar;
    search:searchrec;
const NL=#13#10;

procedure nextdll;
begin
 dllfree(handle);
 findnext(search);
 dllname:=path+search.name;
end;

begin
 writeln(NL+'dllver 1.03 (C) 2000 Virtual Research'+NL);
 if (paramcount<>1) then writeln('Usage: dllver <dllname>') else begin
  dllname:=paramstr(1);
  fsplit(dllname,path,dummy,dummy);
  findfirst(dllname,anyfile and not directory,search);
  if doserror<>0 then begin
   writeln('No files found');
   halt;
  end;
  dllname:=path+search.name;
  while doserror=0 do begin
   writeln('Processing ',dllname);
   handle:=dllload(dllname);
   if dllerror<>NO_ERROR then begin
    writeln(dllerrormessage[dllerror]);
    findnext(search);
    dllname:=path+search.name;
    continue;
   end;
   version:=dllgetversion(handle);
   if (dllerror<>NO_ERROR) and (dllerror<>SYMBOL_NOT_FOUND) then begin
    writeln(dllerrormessage[dllerror]);
    nextdll;
    continue;
   end;
   write('Version: '); if version='' then writeln('n/a') else writeln(version);
   description:=dllgetdummystring(handle);
   if dllerror<>NO_ERROR then begin
    writeln(dllerrormessage[dllerror]);
    nextdll;
    continue;
   end;
   write('Description: '); if description=nil then writeln('n/a') else writeln(description);
   writeln;
   nextdll;
  end;
  writeln('All done.');
 end;
end.

